// license:BSD-3-Clause
// copyright-holders:FIND
////////////////////////////////////////////////////////////////////////////////////////////////////
//
// class AnalyzeWave
// JR-200oCMTg`vOEf[^ɕϊNX
//
// ̃NXJR2Rescuepɏ̂ڐAĂ̂ŁA̗prɂ͖ʂiłʓ|珑Ȃj
//
////////////////////////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#ifdef _WIN32
#include <Shlobj.h>
#include <Shlwapi.h>
#endif
#include <iostream>
#include <fstream>
#include "AnalyzeWave.h"
#include "VJR200.h"
#include "CjrFormat.h"

using namespace std;

AnalyzeWave::AnalyzeWave(vector<uint8_t>* data)
{
	saveData = data;
	bparam.SetBaudRate(LOW); // ŏ̃ubN600baudŒȂ̂lowɐݒ
}

AnalyzeWave::~AnalyzeWave()
{
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  1Tv擾iSAVErBREAKăf[^Ȃꍇ͗Oj
// 
////////////////////////////////////////////////////////////////////////////////////////////////////
int AnalyzeWave::GetSample()
{
	if (convertedList.size() <= readCount)
		throw 1;
	else
		return (int)convertedList[readCount++];
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  ]܂œǂŁA1200HzȂ1A2400HzȂ0AȊOȂ-1Ԃ
// 
////////////////////////////////////////////////////////////////////////////////////////////////////
int AnalyzeWave::GetHalfSpan()
{
	int d, count = 0, retVal = -1;

	// ]܂œǂ
	do 
	{
		d = GetSample();
		wState.SetState(d);
		++count;
	} while (!wState.TurnOver);

	if (count >= param.minSpan && count <= param.maxSpan)
	{
		if (count < ((param.hiFreqSpan + param.lowFreqSpan) / 2.0f)) retVal = 0; else retVal = 1;
	}

	return retVal; // 1200HzȂ1A2400HzȂ0AȊOȂ-1
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  8rbg̔z1oCg̐lɕϊ
// 
////////////////////////////////////////////////////////////////////////////////////////////////////
int AnalyzeWave::BitToByte(int* BitData)
{
	int value = 0;

	for (int i = 0; i < 8; i++)
	{
		value += BitData[i] << i;
	}
	return value;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  JRof[^₷ϊ
// 
////////////////////////////////////////////////////////////////////////////////////////////////////
void AnalyzeWave::SetConvertedList()
{
	for (int i = 0; i < (int)(saveData->size()); ++i) {
		uint8_t b = (*saveData)[i];
		for (int j = 0; j < 8; j++) {
			int8_t c = (b & 1) * 255 -128;
			convertedList.push_back(c);
			b >>= 1;
		}
	}

	/////////////////////// fobOp //////////////////////////
	// ̃̕RgOƁAfobO[hconvertedList̓eBINt@Cɏo
//#ifdef _DEBUG
//	ofstream fout;
//	fout.open("c:\\tmp\\convertedList.bin", ios::out | ios::binary | ios::trunc);
//
//	int8_t* tmp = convertedList.data();
//	for (int i = 0; i < (int)(convertedList.size()); ++i) {
//		fout.write((char *)&convertedList[i], sizeof(uint8_t));
//	}
//	fout.close();
//#endif
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  SAVĚʂCJRƂďo
// 
////////////////////////////////////////////////////////////////////////////////////////////////////
void AnalyzeWave::WriteCjrFile()
{
#ifdef _WIN32
	HANDLE hFile;
	DWORD dwNumberOfBytesWritten;
	uint8_t* writeData;
	int dataSize;
	TCHAR myDocumentsFolder[MAX_PATH];
	TCHAR writePath[MAX_PATH];

	SHGetFolderPath(NULL, CSIDL_MYDOCUMENTS, NULL, NULL, myDocumentsFolder);
	_tcscpy(writePath, myDocumentsFolder);
	_tcscat(writePath, _T("\\save.cjr"));

	int i = 1;
	while (PathFileExists(writePath) && !PathIsDirectory(writePath)) {
		_tcscpy(writePath, myDocumentsFolder);
		TCHAR c[20];
		wsprintf(c, _T("\\save%d.cjr"), i);
		_tcscat(writePath, c);
		++i;
		if (i >= 1000) {
			MessageBox(g_hMainWnd, g_stringTable[23], NULL, 0);
			return;
		}
	}

	CjrFormat cjr;
	cjr.SetCjrData(cjrList.data(), cjrList.size());
	cjr.AdjustBaudRate(0);
	dataSize = cjr.GetCjrSize();
	writeData = cjr.GetCjrDataArray();

	hFile = CreateFile(writePath,
		GENERIC_WRITE,
		0,
		0,
		CREATE_ALWAYS,
		0,
		0
	);
	if (hFile == INVALID_HANDLE_VALUE) {
		MessageBox(g_hMainWnd, g_stringTable[23], NULL, 0);
		return;
	}

	WriteFile(hFile,
		writeData,
		dataSize,
		&dwNumberOfBytesWritten,
		NULL);

	CloseHandle(hFile);
#endif
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  JRog`f[^ϊ
// 
////////////////////////////////////////////////////////////////////////////////////////////////////
bool AnalyzeWave::AnalyzeWavData()
{
	int data = 0;
	int halfWaveCount = 0;
	int cheksumValue;
	bool retVal = false;

	SetConvertedList();

	// [_[ǂݔ΂
	while (GetHalfSpan() != 0);

	// X^[grbgo
	for (int i = 0; i < bparam.hiCycle - 1; i++)
	{
		data = GetHalfSpan();
		if (data == -1) GetHalfSpan();
	}

	blockCount = 0;

	while (true) // f[^̖[܂Ń[v
	{
		for (int i = 0; i < 3; i++) blockHead[i] = 0; // ꉞ
		checkSum = 0;
		dataCount = 0;
		do // 1blockǂݏo[v
		{
			lastData = 0;
			for (int octet = 0; octet < 8; octet++)  // 1byteǂݏo 
			{
				halfWaveCount = 0;
				for (int i = 0; i < bparam.lowCycle; i++)
				{
					int d = GetHalfSpan();
					if (d == -1) d = GetHalfSpan();
					halfWaveCount += d;
				}
				halfWaveCount = (int)round((double)(halfWaveCount / bparam.lowCycle));
				if (halfWaveCount == 0) for (int j = 0; j < bparam.lowCycle; j++) GetHalfSpan(); // 2400Hz(=0) ̂Ƃ͎c̎ǂ݂
				bitData[octet] = halfWaveCount;
			}

			// rbg1oCgɕϊBubNwb_ێ邽߂̏
			int bd = BitToByte(bitData);
			checkSum += bd;
			cjrList.push_back((uint8_t)bd);
			lastData = bd;
			if (dataCount >= 0 && dataCount <= 2) blockHead[dataCount] = (uint8_t)bd;
			dataCount++;

			// Xgbvrbgo
			for (int i = 0; i < bparam.lowCycle * 3; i++) GetHalfSpan();

			// X^[grbg[_[̔
			halfWaveCount = 0;
			for (int i = 0; i < bparam.hiCycle; i++)
			{
				data = GetHalfSpan();
				halfWaveCount += data;
			}
			halfWaveCount = (int)round((double)(halfWaveCount / bparam.hiCycle)); // ϒlƂăX^[grbg(2400Hz = 0)ǂ𔻒
		} while (halfWaveCount == 0); // X^[grbgȂubN[v
										//  1ubNIB

		if (blockCount == 0 && cjrList.size() > 23)
		{
			cheksumValue = (int)cjrList[23];
			if (blockCount == 0 && cheksumValue == 0) bparam.SetBaudRate(HIGH); // wb_ubN݂baud rateύX
		}
		else {
			if (blockCount == 0 && cjrList.size() <= 23)
			{
				return retVal;
			}
		}

		// tb^ubNɒBǂf
		if (blockHead[0] == 2 && blockHead[1] == 0x2a && blockHead[2] == (uint8_t)0xff)
		{
			retVal = true;
			break;
		}

		// [_[ǂݔ΂
		while ((data = GetHalfSpan()) == 1);

		if (data == -1)
			break;

		// X^[grbgo
		for (int i = 0; i < bparam.hiCycle - 1; i++) GetHalfSpan();
		blockCount++;
	}

	return retVal;
}

