// license:BSD-3-Clause
// copyright-holders:FIND
////////////////////////////////////////////////////////////////////////////////////////////////////
//
// class Mn1544
// L[{[h
//
////////////////////////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "JRSystem.h"
#include "Mn1544.h"
#include "VJR200.h"

using namespace std;

extern JRSystem sys;

Mn1544::Mn1544()
{
}


Mn1544::~Mn1544()
{
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// 
//
////////////////////////////////////////////////////////////////////////////////////////////////////
bool Mn1544::Init()
{
	FILE *fp = nullptr;

	pointer = 0;

	fp = _tfopen(g_pFontFile, _T("rb"));
	if (fp == nullptr) {
		_tcscpy(g_pFontFile, _T(""));
		return false;
	}
	fread(fontData, sizeof(fontData[0]), sizeof(fontData), fp);
	fclose(fp);

	fontData[FONTSIZE] = 0; // baud rate

	// OtL[{[hprbg}bvf[^쐬
	int c = 0;
	for (int i = 0; i < 4; ++i) {
		for (int j = 0; j < 8; ++j) {
			for (int k = 0; k < 14; ++k) {
				g_bits1[c++] = ~fontData[g_gcharCode1[i][k] * 8 + j];
			}
		}
	}
	c = 0;
	for (int i = 0; i < 3; ++i) {
		for (int j = 0; j < 8; ++j) {
			for (int k = 0; k < 14; ++k) {
				g_bits2[c++] = ~fontData[g_gcharCode2[i][k] * 8 + j];
			}
		}
	}

	return true;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// /KSTAT̏
//
////////////////////////////////////////////////////////////////////////////////////////////////////
void Mn1544::SetKeyState(uint8_t val)
{
	if (!bInitialized) { // d
		assert(pointer >= 0 && pointer =< FONTSIZE);
		if (prepreKtest != 0 && preKtest == 0 && (val & 2) != 0 && !bKtested) {
			bKtested = true;
			sys.pAddress->WriteByte(0xc801, fontData[pointer]);
			sys.pAddress->WriteByte(0xc809, 0x10);
			++pointer;
		}
		else {
			if (prepreKack != 0 && preKack == 0 && ((val & 1) != 0)) {
				sys.pAddress->WriteByte(0xc801, fontData[pointer]);
				sys.pAddress->WriteByte(0xc809, 0x10);
				++pointer;
			}
		}
		if (pointer == 2049) {
			bInitialized = true;
			bKtested = false;
			pointer = 0;
		}
		prepreKtest = preKtest;
		preKtest = (val & 0x02);
		prepreKack = preKack;
		preKack = (val & 0x01);

	}
	else { // ʏ펞
		assert(pointer >= 0 && pointer =< 2);
		if (prepreKtest != 0 && preKtest == 0 && (val & 2) != 0 && !bScanning) {
			ScanKeyAndPad();
			bScanning = true;
			sys.pAddress->WriteByte(0xc801, scanBuff[pointer]);
			sys.pAddress->WriteByte(0xc809, 0x10);
			++pointer;
		}
		else {
			if (prepreKack != 0 && preKack == 0 && ((val & 1) != 0) && bScanning) {
			sys.pAddress->WriteByte(0xc801, scanBuff[pointer]);
				sys.pAddress->WriteByte(0xc809, 0x10);
				++pointer;
			}
		}
		if (pointer == 3) {
			bScanning = false;
			pointer = 0;
		}
		prepreKtest = preKtest;
		preKtest = (val & 2);
		prepreKack = preKack;
		preKack = (val & 1);
	}
	return;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// L[͏
//
////////////////////////////////////////////////////////////////////////////////////////////////////
uint8_t Mn1544::KeyIn(int w, int l)
{
	uint8_t c = 0;

	if (bAutoTyping) return 0;

	bKeyRepeat = (l & 0x40000000) ? true : false;
	if (w == VK_ESCAPE && bBreakOn == true) {
		c = 3;
		sys.pCpu->nmi();
	} else {
		c = ConvertKeyCode((int)w);
		if (c != 0) {
			sys.pAddress->WriteByte(0xc801, c);
			sys.pAddress->WriteByte(0xc809, 0x10);
		}
	}

	return c;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// L[XLWCXeBbN
//
////////////////////////////////////////////////////////////////////////////////////////////////////
void Mn1544::ScanKeyAndPad()
{
	SHORT s = 0;
	JOYINFOEX jInfo;

	scanBuff[0] = KeyScan();

	jInfo.dwSize = sizeof(JOYINFOEX);
	jInfo.dwFlags = JOY_RETURNALL;

	uint8_t j1 = 0xff, j2 = 0xff;
	if (joyGetPosEx(JOYSTICKID1, &jInfo) == JOYERR_NOERROR) {
		if (jInfo.dwXpos < 0x4000) j1 &= ~4;
		if (jInfo.dwXpos > 0xC000) j1 &= ~8;
		if (jInfo.dwYpos < 0x4000) j1 &= ~1;
		if (jInfo.dwYpos > 0xC000) j1 &= ~2;

		// WCXeBbN[h̏
		if (g_bForcedJoystick) {
			if ((jInfo.dwButtons & g_Joypad1pA) != 0) scanBuff[0] = ConvertKeyCode(g_forcedJoypadA);
			if ((jInfo.dwButtons & g_Joypad1pB) != 0) scanBuff[0] = ConvertKeyCode(g_forcedJoypadB);
			if (jInfo.dwXpos < 0x4000) scanBuff[0] = 0x1d;
			if (jInfo.dwXpos > 0xC000) scanBuff[0] = 0x1c;
			if (jInfo.dwYpos < 0x4000) scanBuff[0] = 0x1e;
			if (jInfo.dwYpos > 0xC000) scanBuff[0] = 0x1f;
		}

		if (!g_b2buttons) {
			if (jInfo.dwButtons != 0)  j1 &= ~16;
		}
		else {
			if ((jInfo.dwButtons & g_Joypad1pA) != 0) j1 &= ~16;
			if ((jInfo.dwButtons & g_Joypad1pB) != 0) j1 &= ~32;
		}
	}

	if (joyGetPosEx(JOYSTICKID2, &jInfo) == JOYERR_NOERROR) {
		if (jInfo.dwXpos < 0x4000) j2 &= ~4;
		if (jInfo.dwXpos > 0xC000) j2 &= ~8;
		if (jInfo.dwYpos < 0x4000) j2 &= ~1;
		if (jInfo.dwYpos > 0xC000) j2 &= ~2;
		if (!g_b2buttons) {
			if (jInfo.dwButtons != 0)  j2 &= ~16;
		}
		else {
			if ((jInfo.dwButtons & g_Joypad2pA) != 0)  j2 &= ~16;
			if ((jInfo.dwButtons & g_Joypad2pB) != 0)  j2 &= ~32;
		}
	}

	if (g_bForcedJoystick)
		scanBuff[1] = 0xff;
	else
		scanBuff[1] = j1;
	scanBuff[2] = j2;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// ͏i^C}[Ij
//
////////////////////////////////////////////////////////////////////////////////////////////////////
void Mn1544::TickCounter(int cycles)
{
	if (bAutoTyping) {
		double tickTime = (double)cycles / (CLOCK * g_cpuScale * 0.01);
		counter += tickTime;
		if (counter > interval) {
			uint8_t keyin = typeWord[typeCount++];
			if (bQuickType) {
				if (keyin == 0x0a)
					keyin = typeWord[typeCount++];
			}
			if (typeCount > wordLen) { // ͏I
				if (bQuickType) {
					delete[] typeWord;
					typeWord = nullptr;
					g_cpuScale = preCpuScale;
				}
				bAutoTyping = false;
				bQuickType = false;
				typeCount = 0;
				typeWord = nullptr;
				return;
			}
			sys.pAddress->WriteByte(0xc801, keyin);
			sys.pMn1271->AssertIrq((int)(IrqType::KON));
			counter = 0;
		}
	}
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// QUICK TYPE X^[g
//
////////////////////////////////////////////////////////////////////////////////////////////////////
void Mn1544::StartQuickType(TCHAR* filename)
{
	HANDLE hFile;
	DWORD dwNumberOfReadBytes;

	hFile = CreateFile(filename,
		GENERIC_READ,
		0,
		0,
		OPEN_EXISTING,
		0,
		0
	);
	if (hFile == INVALID_HANDLE_VALUE) {
		MessageBeep(MB_OK);
		return;
	}

	wordLen = GetFileSize(hFile, NULL);
	if (wordLen > 65536) {
		CloseHandle(hFile);
		MessageBeep(MB_OK);
		return;
	}

	preCpuScale = g_cpuScale;
	g_cpuScale = CPU_SPEED_MAX;
	if (typeWord != nullptr)
		delete[] typeWord;
	typeWord = new uint8_t[wordLen];

	if (!ReadFile(hFile,
		typeWord,
		wordLen / sizeof(typeWord[0]),
		&dwNumberOfReadBytes,
		NULL)) {
		CloseHandle(hFile);
		MessageBeep(MB_OK);
		return;
	};
	CloseHandle(hFile);

	interval = g_quickTypeS * 0.001;
	typeCount = 0;
	bAutoTyping = true;
	bQuickType = true;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// QUICK TYPE Xgbv
//
////////////////////////////////////////////////////////////////////////////////////////////////////
void Mn1544::StopQuickType()
{
	g_cpuScale = preCpuScale;
	bQuickType = false;
	bAutoTyping = false;
	delete[] typeWord;
	typeWord = nullptr;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// CTRL+ꎚ
//
////////////////////////////////////////////////////////////////////////////////////////////////////
void Mn1544::AutoType(const char w[])
{
	typeWord = (uint8_t*)w;
	typeCount = 0;
	wordLen = strlen(w);
	interval = 0.005;
	bQuickType = false;
	bAutoTyping = true;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// L[XL
//
////////////////////////////////////////////////////////////////////////////////////////////////////
uint8_t Mn1544::KeyScan()
{
	uint8_t code[256];
	uint8_t c = 0;
	int w = 0;
	bool bHit = false;

	if (!GetKeyboardState(code)) MessageBox(g_hMainWnd, g_stringTable[29], NULL, 0);

	for (w = 8; w <= 13; ++w) {
		if (code[w] & 0x80) {
			bHit = true;
			break;
		}
	}
	if (!bHit) {
		for (w = 27; w <= 90; ++w) {
			if (code[w] & 0x80) {
				bHit = true;
				break;
			}
		}
	}
	if (!bHit) {
		for (w = 186; w <= 226; ++w) {
			if (code[w] & 0x80) {
				bHit = true;
				break;
			}
		}
	}

	if (!bHit)  return 0;
	c = ConvertKeyCode(w);

	return c;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Windows̃L[R[hJR̃Lɕϊ
//
////////////////////////////////////////////////////////////////////////////////////////////////////
uint8_t Mn1544::ConvertKeyCode(int w)
{
	uint8_t c = 0;
	bool bShift = GetKeyState(VK_SHIFT) < 0 ? true : false;
	bool bCtrl = GetKeyState(VK_CONTROL) < 0 ? true : false;

	// Ctrl+Shift+]: BreakOn/Off
	if (w == 0xdd && bShift && bCtrl) {
		bBreakOn = false;
		return 0;
	}

	if (w == 0xba && bShift && bCtrl) {
		bBreakOn = true;
		return 0;
	}

	switch (w)
	{
	case VK_PRIOR:
	case VK_CONVERT:
		c = 0x80; // GRAPH
		mode = InputType::GRAPH;
		break;
	case VK_NEXT:
	case VK_NONCONVERT:
		c = 0x14; // p
		mode = InputType::ANK;
		break;
	case VK_END:
	case VK_OEM_COPY:
		c = 0xa0; // Ji
		mode = InputType::KANA;
		break;
	case VK_HOME: // HOME CLS
		if (!bShift) c = 0x0b; else c = 0x0c;
		break;
	case VK_INSERT: // INS
		c = 0x13;
		break;
	case VK_DELETE: // DEL
		c = 0x7f;
		break;
	case VK_UP:
		c = 0x1e;
		break;
	case VK_DOWN:
		c = 0x1f;
		break;
	case VK_LEFT:
		c = 0x1d;
		break;
	case VK_RIGHT:
		c = 0x1c;
		break;
	case VK_RETURN: // RETURN
		c = 0xd;
		break;
	case VK_BACK: // RUBOUT
		c = 0x8;
		break;
	case VK_SPACE:
		c = 0x20;
		break;
	case VK_NUMPAD0:
		c = 0x30;
		break;
	case VK_NUMPAD1:
		c = 0x31;
		break;
	case VK_NUMPAD2:
		c = 0x32;
		break;
	case VK_NUMPAD3:
		c = 0x33;
		break;
	case VK_NUMPAD4:
		c = 0x34;
		break;
	case VK_NUMPAD5:
		c = 0x35;
		break;
	case VK_NUMPAD6:
		c = 0x36;
		break;
	case VK_NUMPAD7:
		c = 0x37;
		break;
	case VK_NUMPAD8:
		c = 0x38;
		break;
	case VK_NUMPAD9:
		c = 0x39;
		break;
	case VK_MULTIPLY:
		c = 0x2a;
		break;
	case VK_ADD:
		c = 0x2b;
		break;
	case VK_SUBTRACT:
		c = 0x2d;
		break;
	case VK_DECIMAL:
		c = 0x2e;
		break;
	case VK_DIVIDE:
		c = 0x2f;
		break;
	}


	if (c == 0 && bCtrl == true) {
		if ((sys.pAddress->ReadByte(0xc803) & 0x80) != 0 || bShift == true) {
			// j[g[h
			if (w == 'A') c = 0x01;
			if (w == 'B') c = 0x02;
			if (w == 'C') c = 0x03;
			if (w == 'D') c = 0x04;
			if (w == 'E') c = 0x05;
			if (w == 'F') c = 0x06;
			if (w == 'G') c = 0x07;
			if (w == 'H') c = 0x08;
			if (w == 'I') c = 0x09;
			if (w == 'J') c = 0x0a;
			if (w == 'K') c = 0x0b;
			if (w == 'L') c = 0x0c;
			if (w == 'M') c = 0x0d;
			if (w == 'N') c = 0x0e;
			if (w == 'O') c = 0x0f;
			if (w == 'P') c = 0x10;
			if (w == 'Q') c = 0x11;
			if (w == 'R') c = 0x12;
			if (w == 'S') c = 0x13;
			if (w == 'T') c = 0x14;
			if (w == 'U') c = 0x15;
			if (w == 'V') c = 0x16;
			if (w == 'W') c = 0x17;
			if (w == 'X') c = 0x18;
			if (w == 'Y') c = 0x19;
			if (w == 'Z') c = 0x1a;
			if (w == 0xdb) c = 0x1b;

		}
		else {
			// BASIC[h
			if (!bKeyRepeat) {
				if (w == '1') c = 0xc;
				if (w == '2') c = 0xb;
				if (w == 'Z') c = 0x1a;
				if (w == 'X') c = 0x18;
				if (w == 'C') c = 0x03;
				if (w == 'V') c = 0x16;

				if (mode == InputType::ANK) {
					if (w == '3') AutoType("SAVE ");
					if (w == '4') AutoType("LOAD ");
					if (w == '5') AutoType("VERIFY ");
					if (w == '6') AutoType("OPEN ");
					if (w == '7') AutoType("CLOSE ");
					if (w == '8') AutoType("PLAY ");
					if (w == '9') AutoType("TEMPO ");
					if (w == '0') AutoType("BEEP ");
					if (w == 0xbd) AutoType("COLOR ");
					if (w == 0xde) AutoType("CLEAR ");
					if (w == 0xdc) AutoType("DELETE ");

					if (w == 'Q') AutoType("GOSUB ");
					if (w == 'W') AutoType("RETURN");
					if (w == 'E') AutoType("END");
					if (w == 'R') AutoType("RUN ");
					if (w == 'T') AutoType("THEN ");
					if (w == 'Y') AutoType("LOCATE ");
					if (w == 'U') AutoType("IF ");
					if (w == 'I') AutoType("INPUT ");
					if (w == 'O') AutoType("PLOT ");
					if (w == 'P') AutoType("PRINT ");
					if (w == 0xc0) AutoType("RANDOMIZE");
					if (w == 0xdb) AutoType("FIND ");

					if (w == 'A') AutoType("AUTO ");
					if (w == 'S') AutoType("STOP");
					if (w == 'D') AutoType("DIM ");
					if (w == 'F') AutoType("FOR ");
					if (w == 'G') AutoType("GOTO ");
					if (w == 'H') AutoType("POKE ");
					if (w == 'J') AutoType("RND(");
					if (w == 'K') AutoType("READ ");
					if (w == 'L') AutoType("LIST ");
					if (w == 0xbb) AutoType("CHR$(");
					if (w == 0xba) AutoType("REM ");
					if (w == 0xdd) AutoType("CONT");

					if (w == 'B') AutoType("RESTORE ");
					if (w == 'N') AutoType("NEXT ");
					if (w == 'M') AutoType("MON");
					if (w == 0xbc) AutoType("DATA ");
					if (w == 0xbe) AutoType("PEEK(");
					if (w == 0xbf) AutoType("HEX$(");
					if (w == 0xe2) AutoType("PICK ");

					return c;
				}
			}
			else {
				return 0;
			}
		}
	}


	if (c == 0) {
		switch (mode)
		{
		case InputType::ANK:
			if (w == 0x30 && !bShift) c = 0x30;
			if (w >= 0x31 && w <= 0x39) {
				if (!bShift) c = w;
				else c = w - 0x10;
			}
			if (w >= 0x41 && w <= 0x5A) {
				if (!bShift) c = w + 0x20;
				else c = w;
			}
			if (c == 0) {
				switch (w)
				{
				case 0xba: // colon
					if (!bShift) c = 0x3a;	else c = 0x2a;
					break;
				case 0xbb: // semi colon
					if (!bShift) c = 0x3b;  else c = 0x2b;
					break;
				case 0xbc: // comma
					if (!bShift) c = 0x2c;  else c = 0x3c;
					break;
				case 0xbd: // minus
					if (!bShift) c = 0x2d;  else c = 0x3d;
					break;
				case 0xbe: // period
					if (!bShift) c = 0x2e;  else c = 0x3e;
					break;
				case 0xbf: // slash
					if (!bShift) c = 0x2f;  else c = 0x3f;
					break;
				case 0xc0: // at
					if (!bShift) c = 0x40;  else c = 0x60;
					break;
				case 0xdb: // kaku kakko
					if (!bShift) c = 0x5b;  else c = 0x7b;
					break;
				case 0xdc: // yen
					if (!bShift) c = 0x5c;  else c = 0x7c;
					break;
				case 0xdd: // kaku kakko
					if (!bShift) c = 0x5d;  else c = 0x7d;
					break;
				case 0xde: // hat
					if (!bShift) c = 0x5e;  else c = 0x7e;
					break;
				case 0xe2: // underbar
					if (bShift) c = 0x5f;
					break;
				}
			}

			break;
		case InputType::KANA:
			switch (w)
			{
			case '3':
				if (!bShift) c = ''; else c = '';
				break;
			case 'E':
				if (!bShift) c = ''; else c = '';
				break;
			case '4':
				if (!bShift) c = ''; else c = '';
				break;
			case '5':
				if (!bShift) c = ''; else c = '';
				break;
			case '6':
				if (!bShift) c = ''; else c = '';
				break;
			case 'T':
				if (!bShift) c = '';
				break;
			case 'G':
				if (!bShift) c = '';
				break;
			case 'H':
				if (!bShift) c = '';
				break;
			case 0xBA:
				if (!bShift) c = '';
				break;
			case 'B':
				if (!bShift) c = '';
				break;
			case 'X':
				if (!bShift) c = '';
				break;
			case 'D':
				if (!bShift) c = '';
				break;
			case 'R':
				if (!bShift) c = '';
				break;
			case 'P':
				if (!bShift) c = '';
				break;
			case 'C':
				if (!bShift) c = '';
				break;
			case 'Q':
				if (!bShift) c = '';
				break;
			case 'A':
				if (!bShift) c = '';
				break;
			case 'Z':
				if (!bShift) c = ''; else c = '';
				break;
			case 'W':
				if (!bShift) c = '';
				break;
			case 'S':
				if (!bShift) c = '';
				break;
			case 'U':
				if (!bShift) c = '';
				break;
			case 'I':
				if (!bShift) c = '';
				break;
			case '1':
				if (!bShift) c = '';
				break;
			case 0xBC:
				if (!bShift) c = ''; else c = '';
				break;
			case 'K':
				if (!bShift) c = '';
				break;
			case 'F':
				if (!bShift) c = '';
				break;
			case 'V':
				if (!bShift) c = '';
				break;
			case '2':
				if (!bShift) c = '';
				break;
			case 0xDE:
				if (!bShift) c = '';
				break;
			case 0xBD:
				if (!bShift) c = '';
				break;
			case 'J':
				if (!bShift) c = '';
				break;
			case 'N':
				if (!bShift) c = '';
				break;
			case 0xDD:
				if (!bShift) c = ''; else c = '';
				break;
			case 0xBF:
				if (!bShift) c = ''; else c = '';
				break;
			case 'M':
				if (!bShift) c = '';
				break;
			case '7':
				if (!bShift) c = ''; else c = '';
				break;
			case '8':
				if (!bShift) c = ''; else c = '';
				break;
			case '9':
				if (!bShift) c = ''; else c = '';
				break;
			case 'O':
				if (!bShift) c = '';
				break;
			case 'L':
				if (!bShift) c = '';
				break;
			case 0xBE:
				if (!bShift) c = ''; else c = '';
				break;
			case 0xBB:
				if (!bShift) c = '';
				break;
			case 0xe2:
				if (!bShift) c = '';
				break;
			case '0':
				if (!bShift) c = ''; else c = '';
				break;
			case 'Y':
				if (!bShift) c = '';
				break;
			case 0xC0:
				if (!bShift) c = '';
				break;
			case 0xDB:
				if (!bShift) c = ''; else c = '';
				break;
			case 0xDC:
				if (!bShift) c = '';
				break;

			}
			break;
		case InputType::GRAPH:
			switch (w)
			{
			case '1':
				if (!bShift) c = 0x81;
				break;
			case '2':
				if (!bShift) c = 0x82;
				break;
			case '3':
				if (!bShift) c = 0x83;
				break;
			case '4':
				if (!bShift) c = 0x84;
				break;
			case '5':
				if (!bShift) c = 0x85;
				break;
			case '6':
				if (!bShift) c = 0x86;
				break;
			case '7':
				if (!bShift) c = 0x87;
				break;
			case '8':
				if (!bShift) c = 0x88;
				break;
			case '9':
				if (!bShift) c = 0x89;
				break;

			case 0xbd:
				if (!bShift) c = 0xed;
				break;
			case 0xde:
				if (!bShift) c = 0x8c;
				break;
			case 0xdc:
				if (!bShift) c = 0x8e;
				break;
			case 0xc0:
				if (!bShift) c = 0xea;
				break;

			case 'M':
				if (!bShift) c = 0x8a; else c = 0x8b;
				break;
			case '^':
				if (!bShift) c = 0x8c;
				break;
			case 'O':
				if (!bShift) c = 0x8d; else c = 0x9d;
				break;
			case '\\':
				if (!bShift) c = 0x8e;
				break;
			case 'T':
				if (!bShift) c = 0xeb; else c = 0x8f;
				break;
			case 'I':
				if (!bShift) c = 0x90; else c = 0xfe;
				break;
			case 'A':
				if (!bShift) c = 0x91; else c = 0xf1;
				break;
			case 'S':
				if (!bShift) c = 0x92; else c = 0xf7;
				break;
			case 'D':
				if (!bShift) c = 0x93; else c = 0xe5;
				break;
			case 'F':
				if (!bShift) c = 0x94; else c = 0xf2;
				break;
			case 'G':
				if (!bShift) c = 0x95; else c = 0xf4;
				break;
			case 'H':
				if (!bShift) c = 0x96; else	c = 0xf9;
				break;
			case 'J':
				if (!bShift) c = 0x97; else	c = 0xf5;
				break;
			case 'Q':
				if (!bShift) c = 0x98; else c = 0x9e;
				break;
			case 'E':
				if (!bShift) c = 0x99; else c = 0x9f;
				break;
			case 'Y':
				if (!bShift) c = 0x9a;
				break;
			case 'W':
				if (!bShift) c = 0x9b; else c = 0xff;
				break;
			case 'R':
				if (!bShift) c = 0xec; else c = 0x9c;
				break;
			case 'P':
				if (!bShift) c = 0xe0; else c = 0xfc;
				break;
			case 'Z':
				if (!bShift) c = 0xfa; else c = 0xe1;
				break;
			case 'B':
				if (!bShift) c = 0xe2; else c = 0xe7;
				break;
			case 'C':
				if (!bShift) c = 0xe3; else c = 0xe4;
				break;
			case 'V':
				if (!bShift) c = 0xf6; else c = 0xe6;
				break;
			case 'N':
				if (!bShift) c = 0xee; else c = 0xe8;
				break;
			case 'U':
				if (!bShift) c = 0xe9;
				break;
			case '@':
				if (!bShift) c = 0xea;
				break;
			case '-':
				if (!bShift) c = 0xed;
				break;
			case 'K':
				if (!bShift) c = 0xef; else c = 0xfb;
				break;
			case 'L':
				if (!bShift) c = 0xf0; else c = 0xfd;
				break;
			case 'X':
				if (!bShift) c = 0xf8;  else c = 0xf3;
				break;
			}
			break;
		}
	}
	return c;
}